<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { ref, computed, inject } from 'vue'
import MailChooser from '@/components/general/form/MailChooser.vue'
import { request } from '@/lib/request'
import { useRouter } from 'vue-router';
import { useI18n } from 'vue-i18n';
import { validMail } from '@/lib/utils';
import Input from '@/components/general/form/Input.vue';
import Button from '@/components/general/Button.vue';
import Modal from '@/components/general/Modal.vue';

const { t } = useI18n();
const $t = t;

const router = useRouter();
const accesscode = ref('');
const showError = ref(false);
let configuration = inject<any>('configuration');
const validUsername = ref(false);
const domain = ref('');
const username = ref('');
const success = ref(false);
const isAccountExisting = ref(false);
const notValid = ref(false);

const props = defineProps<{
    redirect?: boolean
}>();

const emits = defineEmits<{
    (e: "close"): void,
}>();


const getAccessCodeFinderURL = configuration.accessCode.finderURL;

const getAccessCodeFinderLabel = configuration.accessCode.finderLabel;

const mail = ref(computed({
    get: () => username.value + domain.value,
    set: () => { }
}));

const setDomain = (value: any) => {
    domain.value = value;
};
const setUsername = (value: any) => {
    username.value = value;
    validUsername.value = validMail(value);
};
const requestMail = async () => {
    isAccountExisting.value = false;
    let result = await request('POST', configuration.apiServer + "/api/registration/",
        {
            username: username.value,
            domain: domain.value,
            mail: mail.value,
            accesscode: accesscode.value
        });
    if (result.message !== undefined && result.message === "account-existing" && result.success) {
        isAccountExisting.value = true;
        success.value = result.success;
    }
    else if (result.success) {
        success.value = result.success;
        document.title = $t('general.variables.name') + '-' + $t('general.variables.account.sg') + ' ' + $t('general.variables.created');
    }
    else {
        success.value = true;
        notValid.value = true;
    }
};

document.title = $t('general.variables.name') + '-' + $t('general.variables.account.sg') + ' ' + $t('general.variables.create');

const goToHome = () => {
    router.push({ name: "home" });
}

const handleSubmit = ()=>{
    if(!success.value){
        requestMail();
    }else{
       handleCancel();
    }
}

const handleCancel = ()=>{
    if(props.redirect){
        router.push({name: "home"});
    }else{
        emits('close');
    }
}

const disableSubmit = computed(()=>{
    if(success.value){
        if(notValid.value) return true;
        else return false
    }else{
        if(validUsername.value && accesscode.value && accesscode.value.length>0) return false;
        else return true;
    }
});

</script>
<template>
    <Modal :labelSubmit="!success?$t('administration.submit'):$t('confirmationPage.backToStart')" :labelCancel="$t('general.buttons.cancel')" :disableSubmit="disableSubmit"
        @submit="handleSubmit" :header="$t('general.variables.name') + '-' + $t('general.variables.account.sg') + ' ' + $t('general.variables.create')" @cancel="handleCancel">
        <div v-if="!success">
            <fieldset class="flex flex-col gap-1">
                <MailChooser @error="e => validUsername = e" @domain="setDomain" @mail="setUsername" />
                <Input type="text" v-model="accesscode" :placeholder='$t("placeholder.accesscode")'
                    :required="true" icon="home-2" />
                <div>
                    <div class="mt-2 w-full text-center"
                        v-if="getAccessCodeFinderURL && getAccessCodeFinderLabel">
                        <a class="align-middle" :href="getAccessCodeFinderURL" target="_blank" rel="noopener">{{
                            getAccessCodeFinderLabel }}</a>
                    </div>
                </div>
            </fieldset>
        </div>
        <div v-else>
            <span v-if="notValid">
                <p class="text-center mb-4 text-red-700" v-html="$t('confirmationPage.text.error.noAccess')">
                </p>
            </span>
            <span v-else>
                <p class="mb-4 text-red-700" v-if="!isAccountExisting">
                    {{ $t('confirmationPage.text.partOne') }}{{ domain }}{{ $t('confirmationPage.text.partTwo')
                    }}</p>
                <p class="mb-4" v-else>{{ $t('confirmationPage.text.error.accountExists') }}</p>
            </span>
        </div>
    </Modal>
</template>